unit PermanentModuleUnit;

interface

{$I SxInclude.inc}

uses
    SysUtils,
    Classes,
    SxPmtDataModule,
    SxProvider,
    SxIconList,
    Menus,
    {$IFDEF SHELLPLUS_DEBUG}
    DbugIntf,
    {$ENDIF}
    SxPopupMenu, ExtCtrls, Dialogs, ExMegaDemoServer_TLB,
    ComObj, ActiveX, SxNameSpaceUtils, ImgList, Controls, ActnList,
    SxCustShlObj, SxPropertySheetExt, SxNamespacePropSheet, FileObjPropSheetUnit,
    Forms, Windows, SxConst, AxCtrls, SxTools, ShlObj, Graphics,
    SxExtraSecurityPage, SxSecurity, SxGrainExtensions,
    SxThemes, SxPidlTools;

type
  TPermanentModule = class(TSxPermanentModule)
    DataProvider: TSxByHandProvider;
    FileFolderMenu: TSxGrainMenu;
    N2: TMenuItem;
    Images: TImageList;
    FileObjPropSheet: TSxNamespacePropertySheet;
    ExplorerMenuItems: TSxGrainMenu;
    miAbout: TSxGrainMenuItem;
    miShowGrainPath: TSxGrainMenuItem;
    ToolbarImageList: TImageList;
    SmallOverlayIcons: TSxIconList;
    LargeOverlayIcons: TSxIconList;
    ShellPlusItem1: TSxGrainMenuItem;
    ShellPlusItem2: TSxGrainMenuItem;
    ShellPlusItem3: TSxGrainMenuItem;
    SecurityPage: TsxExtraSecurityPropPage;
    GrainExtensionPage: TSxGrainExtensionPage;
    SmallToolbarImages: TImageList;
    BackgroundMenu: TSxGrainMenu;
    MenuItem1: TMenuItem;
    miNewFolder: TSxGrainMenuItem;
    MenuItem2: TMenuItem;
    SxGrainMenuItem2: TSxGrainMenuItem;
    SxGrainMenuItem3: TSxGrainMenuItem;
    SxGrainMenuItem4: TSxGrainMenuItem;
    ExtraLargeOverlayIcons: TSxIconList;
    FilePopupMenu: TSxGrainMenu;
    miModifyCurrentItemName: TSxGrainMenuItem;
    CommonMenuItems: TSxGrainMenu;
    ShellPlusItem4: TSxGrainMenuItem;
    N1: TMenuItem;
    Logout1: TMenuItem;
    procedure DataProviderPopulate(Sender: TSxByHandProvider;
      DataGrain: TSxByHandDataGrain; GrainList: TList);
    procedure SxPermanentModuleCreate(Sender: TObject);
    procedure SxPermanentModuleDestroy(Sender: TObject);
    procedure DataProviderGetFolderContextMenu(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var PopupMenu: TPopupMenu);
    procedure DataProviderQueryRenameGrain(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var AllowRename: Boolean);
    procedure DataProviderQueryDeleteGrain(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var AllowDelete: Boolean);
    procedure DataProviderRenameDataGrain(Sender: TSxCustomProvider;
      ParentGrain, DataGrain: TSxCustomDataGrain; var NewName: WideString;
      var PerformRename: Boolean);
    procedure DataProviderHandleDelete(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain);
    procedure DataProviderPreparePropertySheets(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain;
      var PropSheets: TSxCustomNamespacePropSheet);
    procedure DataProviderGetBackgroundContextMenu(
      Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
      var PopupMenu: TPopupMenu);
    procedure FileObjPropSheetApplyEx(Sender: TSxShellPropSheetExt;
      PropSheet: TForm; var ApplyChanges: Boolean);
    procedure DataProviderGetGrainFileInfo(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var FileInfo: TSxFileInfoDescriptor);
    procedure DataProviderGetGrainFileContents(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; Stream: TMemoryStream);
    procedure DataProviderNewGrainFromStream(Sender: TSxCustomProvider;
      FolderGrain: TSxCustomDataGrain; FileInfo: TSxFileInfoDescriptor;
      FileData: TStream);
    procedure DataProviderGrainMoved(Sender: TSxCustomProvider;
      DataGrains: TSxDataGrainList);
    procedure DataProviderGetIcon(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var IconIndex,
      OpenIconIndex: Integer);
    procedure miAboutClick(Sender: TObject);
    procedure miShowGrainPathClickGrainList(Sender: TSxMenuItem;
      DataGrainList: TSxDataGrainList);
    procedure DataProviderPrepareGrainApperance(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var IconParams: TSxPrepareIconParams);
    procedure DataProviderGetOverlayIndex(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var OverlayIndex: Integer;
      var DisplayOverlay: Boolean);
    procedure DataProviderCreateNewFolder(Sender: TSxCustomProvider;
      OwnerFolderGrain: TSxCustomDataGrain; NewFolderName: WideString;
      out NewFolderGrain: TSxCustomDataGrain);
    procedure DataProviderHandleModify(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; DataStream: TStream);
    procedure DataProviderValidateDataGrain(Sender: TSxCustomProvider;
      FolderGrain, DataGrain: TSxCustomDataGrain;
      var IsDataGrainValid: Boolean);
    procedure ShellPlusItem2ClickGrain(Sender: TSxMenuItem;
      DataGrain: TSxCustomDataGrain);
    procedure ShellPlusItem3ClickGrain(Sender: TSxMenuItem;
      DataGrain: TSxCustomDataGrain);
    procedure DataProviderGrainOpen(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; var CommandString, Parameters,
      Directory: WideString);
    procedure SecurityPageGetGenericMapping(Sender: TsxCustomExtraPropPage;
      PropSheets: TSxShellPropSheetExt; var Mapping: _GENERIC_MAPPING);
    procedure SecurityPageGetAccessRights(Sender: TsxCustomExtraPropPage;
      PropSheets: TSxShellPropSheetExt; var Access: PSI_ACCESS;
      var Accesses, DefaultAccess: Cardinal);
    procedure DataProviderConfirmOverwriteFolder(Sender: TSxCustomProvider;
      AFolder: TSxCustomDataGrain; wnd: HWND; var AllowOverwrite: Boolean);
    procedure DataProviderNewGrainFromFileEx(Sender: TSxCustomProvider;
      FolderGrain: TSxCustomDataGrain; FileName: WideString;
      var NewGrain: TSxCustomDataGrain; var DropInfo: TSxDropInfo);
    procedure miNewFolderClickGrain(Sender: TSxMenuItem;
      DataGrain: TSxCustomDataGrain);
    procedure miModifyCurrentItemNameClickGrain(Sender: TSxMenuItem;
      DataGrain: TSxCustomDataGrain);
    procedure DataProviderQueryDataGrainDropEx(Sender: TSxCustomProvider;
      FolderGrain, DataGrain: TSxCustomDataGrain;
      var DropQueryInfo: TSxDropQuery);
    procedure ShellPlusItem4ClickGrainList(Sender: TSxMenuItem;
      DataGrainList: TSxDataGrainList);
    procedure DataProviderGetDataGrainThumb(Sender: TSxCustomProvider;
      DataGrain: TSxCustomDataGrain; Size: TSxSize; var Thumb: TBitmap);
    procedure Logout1Click(Sender: TObject);
  private
    FLoggedIn: Boolean;
    LogoutTime: TTimeStamp;
    FMDServer: IMDServer;
    procedure SetLoggedIn(const Value: Boolean);
    function GetLoggedIn: Boolean;
    procedure SetLogoutTime;
    function GetMDServer:IMDServer;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function CreateGrainFromStg(stg:IMDFileObj;ParentGrain:TSxCustomDataGrain):TSxByHandDataGrain;
    function DoLogin:Boolean;
    procedure DoLogout;
    property LoggedIn:Boolean read GetLoggedIn write SetLoggedIn;
    property MDServer:IMDServer read GetMDServer write FMDServer;
  end;

const
  vGrainPath='vGrainPath';
  vSysIconOnly='vGrainSysIconOnly';
  folderID_Files='{A0283B15-5B9C-4435-9056-33881A4663D0}';
  folderID_TreeView='{615E7953-798C-4149-A1AA-714BFF155355}';
  folderID_Grid='{18A3DEB3-4047-4BCF-903C-02FF6A74486D}';
  LOGOUT_TIMEOUT=50000;

var
  PermanentModule:TPermanentModule;
  access_list: array [0..18] of SI_ACCESS;

implementation

uses
  LoginDialogUnit,
  {$IFNDEF LESS_THAN_D6}
  Variants,
  {$ENDIF}
  NewGrainUnit;

{$R *.DFM}

function TPermanentModule.GetMDServer:IMDServer;
var
  unk:IUnknown;
begin
  try
    if (FMDServer=nil) or (FMDServer.TestServer(1234567)<>1234567) then
    begin
      if Failed(GetActiveObject(CLASS_MDServer,nil,unk)) then
      begin
        CoInitializeEx(nil,COINIT_APARTMENTTHREADED);
        GetActiveObject(CLASS_MDServer,nil,unk);
      end;
      if unk<>nil then
      begin
        Result:=unk as IMDServer;
        FMDServer:=Result;
      end
      else
         Result:=CoMDServer.Create;
    end
    else
      Result:=FMDServer;
  except
    FMDServer:=CoMDServer.Create;
    Result:=FMDServer;
  end;
end;

procedure TPermanentModule.DataProviderPopulate(Sender: TSxByHandProvider;
  DataGrain: TSxByHandDataGrain; GrainList: TList);
var
  tempGrain:TSxCustomDataGrain;
  grainString:String;
  stgFileObj:IMDFileObj;
  i:Integer;
  tempStr:TStrings;
  tempWideString:WideString;
  tempStgObj:IMDFileObj;
begin
  if not LoggedIn then
  begin
    if not DoLogin then
       Exit;
  end
  else
    SetLogoutTime;
  if DataGrain.IsRoot then // DataGrain is a folder, that need to be populated
  begin
    // Creating first folder (it will display files)
    tempGrain:=Sender.CreateGrainInstance;
    tempGrain.Name:='Stored Files';
    tempGrain.GrainType:=gtFolder;
    tempGrain.Strings.Values[vGrainPath]:=folderID_Files;
    tempGrain.Strings.Values[vSysIconOnly]:='1';
    GrainList.Add(tempGrain); // adding newly created item to the list
//    // Creating second folder (it will contain TreeView with files inside)
//    tempGrain:=Sender.CreateGrainInstance;
//    tempGrain.Name:='Files in TreeView';
//    tempGrain.GrainType:=gtFolder;
//    tempGrain.Strings.Values[vGrainPath]:=folderID_TreeView;
//    tempGrain.Strings.Values[vSysIconOnly]:='1';
//    GrainList.Add(tempGrain);
//    // Creating third folder (it will contain abstract data in the grid)
//    tempGrain:=Sender.CreateGrainInstance;
//    tempGrain.Name:='Abstract Form';
//    tempGrain.GrainType:=gtFolder;
//    tempGrain.Strings.Values[vGrainPath]:=folderID_Grid;
//    tempGrain.Strings.Values[vSysIconOnly]:='1';
//    GrainList.Add(tempGrain);
  end
  else
  begin
    grainString:=DataGrain.Strings.Values[vGrainPath]; // Enumerated grain path
    stgFileObj:=nil;
    if grainString=folderID_Files then
    begin
      if Failed(MDServer.GetFileStorage(stgFileObj)) then // Displaying files
         Exit;
    end
    else
    if grainString=folderID_TreeView then // Displaying file tree view
    begin
      Exit;
    end
    else
    if grainString=folderID_Grid then // Displaying data in grid
    begin
      Exit;
    end
    else
    begin // working with some file grain (the string is a path)
      if Failed(MDServer.GetRelativeFileStorage(grainString,stgFileObj)) then // Displaying files
         Exit;
    end;
    if stgFileObj=nil then
       Exit;
    tempStr:=TStringList.Create;
    try
      stgFileObj.GetChildNames(tempWideString); // retreiving the list of childs
      tempStr.Text:=tempWideString; // to make things easy...
      for i:=0 to tempStr.Count-1 do
      begin
        stgFileObj.GetChildByName(tempStr[i],tempStgObj); // retreiving child's object
        if tempStgObj=nil then
           Continue;
        tempGrain:=CreateGrainFromStg(tempStgObj,DataGrain);
        if tempGrain.GrainType = gtItem then // Demonstrating custom ShellAttributes for any DataGrain
           tempGrain.ShellAttributes:=tempGrain.ShellAttributes+[saGhosted];
        GrainList.Add(tempGrain);
      end;
    finally
      FreeAndNil(tempStr);
    end;
  end;
end;

procedure TPermanentModule.SetLoggedIn(const Value: Boolean);
begin
  FLoggedIn := Value;
  if Value then
     SetLogoutTime;
end;

procedure TPermanentModule.DoLogout;
begin
  LoggedIn:=False;
  DataProvider.CloseWholeTree;
end;

procedure TPermanentModule.SxPermanentModuleCreate(Sender: TObject);
begin
  PermanentModule:=Self;
  LoggedIn:=False;
  MDServer:=nil;

  access_list[0].pguid:=nil;
  access_list[0].mask:=FILE_READ_DATA or FILE_WRITE_DATA or FILE_APPEND_DATA or
              {FILE_READ_EX or }FILE_WRITE_EA or FILE_EXECUTE or FILE_DELETE_CHILD or
              FILE_READ_ATTRIBUTES or FILE_WRITE_ATTRIBUTES or DELETE or READ_CONTROL or
              WRITE_DAC or WRITE_OWNER or SYNCHRONIZE;
  access_list[0].pszName:='Full Control';
  access_list[0].dwFlags:=SI_ACCESS_GENERAL;

  access_list[1].pguid:=nil;
  access_list[1].mask:=FILE_READ_DATA or FILE_WRITE_DATA or FILE_APPEND_DATA or
                       FILE_READ_EA or FILE_WRITE_EA or FILE_EXECUTE or FILE_READ_ATTRIBUTES or DELETE
                       or READ_CONTROL or SYNCHRONIZE;
  access_list[1].pszName:='Modify';
  access_list[1].dwFlags:=SI_ACCESS_GENERAL;

  access_list[2].pguid:=nil;
  access_list[2].mask:=FILE_READ_DATA or FILE_READ_EA or FILE_EXECUTE or
                       FILE_READ_ATTRIBUTES or READ_CONTROL or SYNCHRONIZE;
  access_list[2].pszName:='Read & Execute';
  access_list[2].dwFlags:=SI_ACCESS_GENERAL;

  access_list[3].pguid:=nil;
  access_list[3].mask:=FILE_READ_DATA or FILE_READ_EA or FILE_EXECUTE or
                       FILE_READ_ATTRIBUTES or READ_CONTROL or SYNCHRONIZE;
  access_list[3].pszName:='List Folder Contents';
  access_list[3].dwFlags:=SI_ACCESS_GENERAL or SI_ACCESS_CONTAINER;

  access_list[4].pguid:=nil;
  access_list[4].mask:=FILE_READ_DATA or FILE_READ_ATTRIBUTES or FILE_READ_EA or
                       READ_CONTROL or SYNCHRONIZE;
  access_list[4].pszName:='Read';
  access_list[4].dwFlags:=SI_ACCESS_GENERAL;

  access_list[5].pguid:=nil;
  access_list[5].mask:=FILE_READ_DATA or FILE_WRITE_DATA or FILE_EXECUTE or
                       FILE_DELETE_CHILD or FILE_WRITE_ATTRIBUTES or SYNCHRONIZE;
  access_list[5].pszName:='Write';
  access_list[5].dwFlags:=SI_ACCESS_GENERAL;

  access_list[6].pguid:=nil;
  access_list[6].mask:=FILE_EXECUTE or SYNCHRONIZE;
  access_list[6].pszName:='Traverse Folder';
  access_list[6].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[7].pguid:=nil;
  access_list[7].mask:=FILE_READ_DATA or SYNCHRONIZE;
  access_list[7].pszName:='List Folder';
  access_list[7].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[8].pguid:=nil;
  access_list[8].mask:=FILE_READ_ATTRIBUTES or SYNCHRONIZE;
  access_list[8].pszName:='Read Attributes';
  access_list[8].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[9].pguid:=nil;
  access_list[9].mask:=FILE_READ_EA or SYNCHRONIZE;
  access_list[9].pszName:='Read Extended Attributes';
  access_list[9].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[10].pguid:=nil;
  access_list[10].mask:=FILE_WRITE_DATA or SYNCHRONIZE;
  access_list[10].pszName:='Create Files / Write Data';
  access_list[10].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[11].pguid:=nil;
  access_list[11].mask:=FILE_APPEND_DATA or SYNCHRONIZE;
  access_list[11].pszName:='Create Folders / Append Data';
  access_list[11].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[12].pguid:=nil;
  access_list[12].mask:=FILE_WRITE_ATTRIBUTES or SYNCHRONIZE;
  access_list[12].pszName:='Write Attributes';
  access_list[12].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[13].pguid:=nil;
  access_list[13].mask:=FILE_WRITE_EA or SYNCHRONIZE;
  access_list[13].pszName:='Write Extended Attributes';
  access_list[13].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[14].pguid:=nil;
  access_list[14].mask:=FILE_DELETE_CHILD or SYNCHRONIZE;
  access_list[14].pszName:='Delete Subfolders and Files';
  access_list[14].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[15].pguid:=nil;
  access_list[15].mask:=DELETE or SYNCHRONIZE;
  access_list[15].pszName:='Delete';
  access_list[15].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[16].pguid:=nil;
  access_list[16].mask:=READ_CONTROL or SYNCHRONIZE;
  access_list[16].pszName:='Read Permissions';
  access_list[16].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[17].pguid:=nil;
  access_list[17].mask:=WRITE_DAC or SYNCHRONIZE;
  access_list[17].pszName:='Change Permissions';
  access_list[17].dwFlags:=SI_ACCESS_SPECIFIC;

  access_list[18].pguid:=nil;
  access_list[18].mask:=WRITE_OWNER or SYNCHRONIZE;
  access_list[18].pszName:='Take Ownership';
  access_list[18].dwFlags:=SI_ACCESS_SPECIFIC;
end;

function TPermanentModule.DoLogin: Boolean;
var
  tempLoginForm:TLoginForm;
  context:TSxContext;
begin
  Result:=False;
  context:=TsxContext.Create;
  try
    tempLoginForm:=TLoginForm.Create(Self);
    try
      if tempLoginForm.ShowModal=mrOk then
      begin
        LoggedIn:=True;
        Result:=True;
      end
      else
        DoLogout;
    finally
      FreeAndNil(tempLoginForm);
    end;
  finally
    FreeAndNil(context);
  end;
end;

function TPermanentModule.GetLoggedIn: Boolean;
var
  tempTime:TTimeStamp;
begin
  Result:=FLoggedIn;
  if Result=True then
  begin
    tempTime:=DateTimeToTimeStamp(Time);
    Result:=tempTime.Date=LogoutTime.Date;
    if Result then
       Result:=tempTime.Time<=LogoutTime.Time;
    FLoggedIn:=Result;
  end;
end;

procedure TPermanentModule.SetLogoutTime;
begin
  LogoutTime:=DateTimeToTimeStamp(Time);
  // checking for midnight
  if LogoutTime.Time+100000>86400000 then
  begin
    LogoutTime.Date:=LogoutTime.Date+1;
    LogoutTime.Time:=(LogoutTime.Time+LOGOUT_TIMEOUT)-86400;
  end
  else
    LogoutTime.Time:=LogoutTime.Time+LOGOUT_TIMEOUT;
end;

procedure TPermanentModule.SxPermanentModuleDestroy(Sender: TObject);
begin
  try
    MDServer:=nil;
  except
  end;
  PermanentModule:=nil;
end;

function TPermanentModule.CreateGrainFromStg(
  stg: IMDFileObj;ParentGrain:TSxCustomDataGrain): TSxByHandDataGrain;
begin
  try
    Result:=DataProvider.CreateGrainInstance(ParentGrain) as TSxByHandDataGrain;
    Result.Name:=stg.Name;
    Result.Strings.Values[vGrainPath]:=IncludeTrailingBackslash(ParentGrain.Strings.Values[vGrainPath])
                                                                  +Result.Name;
    Result.GrainID:=Result.Strings.Values[vGrainPath];

    if Stg.IsSystemIcon then
       Result.Strings.Values[vSysIconOnly]:='1'
    else
       Result.Strings.Values[vSysIconOnly]:='0';
    if stg.Kind=0 then
       Result.GrainType:=gtFolder
    else
       Result.GrainType:=gtItem;
    if stg.ReadOnly then
       Result.Attributes:=[ftReadOnly];
  except
    Result:=nil;
  end;
end;

procedure TPermanentModule.DataProviderGetFolderContextMenu(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var PopupMenu: TPopupMenu);
begin
  if (DataGrain.Strings.Values[vGrainPath]=folderID_Files) or
     (Length(DataGrain.Strings.Values[vGrainPath])>38) then
    begin
     PopupMenu := FileFolderMenu;
     PopupMenu.Items[1].Caption := 'New Folder in ' + DataGrain.Name + '...';
    end
  else
     PopupMenu:=nil;
end;

procedure TPermanentModule.DataProviderQueryRenameGrain(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var AllowRename: Boolean);
begin
  AllowRename:=Length(DataGrain.Strings.Values[vGrainPath])>38;
end;

procedure TPermanentModule.DataProviderQueryDeleteGrain(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var AllowDelete: Boolean);
var
  tempFileStg:IMDFileObj;
begin
  AllowDelete:=(Length(DataGrain.Strings.Values[vGrainPath])>38);
  if AllowDelete then
  begin
    MDServer.GetRelativeFileStorage(DataGrain.Strings.Values[vGrainPath],tempFileStg);
    if tempFileStg=nil then
       AllowDelete:=False
    else
       AllowDelete:=not tempFileStg.ReadOnly;
  end;
end;

procedure TPermanentModule.DataProviderRenameDataGrain(
  Sender: TSxCustomProvider; ParentGrain, DataGrain: TSxCustomDataGrain;
  var NewName: WideString; var PerformRename: Boolean);
var
  tempFileStg:IMDFileObj;
begin
  MDServer.GetRelativeFileStorage(ParentGrain.Strings.Values[vGrainPath],tempFileStg);
  if tempFileStg=nil then
     PerformRename:=False
  else
     PerformRename:=Succeeded(tempFileStg.RenameChild(DataGrain.Name,NewName));
end;

procedure TPermanentModule.DataProviderHandleDelete(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain);
var
  res:HRESULT;
begin
  res:=MDServer.DeteleFileStgElement(DataGrain.Strings.Values[vGrainPath]);
  if res=S_FALSE then
     MessageDlg('Can''t delete root folder.', mtError, [mbOK], 0)
  else
  if res=E_ACCESSDENIED then
     MessageDlg('Can''t delete read-only object.', mtWarning, [mbOK], 0);
end;

procedure TPermanentModule.DataProviderPreparePropertySheets(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var PropSheets: TSxCustomNamespacePropSheet);
begin
  if Length(DataGrain.Strings.Values[vGrainPath])>38 then
     PropSheets:=FileObjPropSheet
  else
     PropSheets:=nil;
end;

procedure TPermanentModule.DataProviderGetBackgroundContextMenu(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var PopupMenu: TPopupMenu);
begin
  if (DataGrain.Strings.Values[vGrainPath]=folderID_Files) or
     (Length(DataGrain.Strings.Values[vGrainPath])>38) then
     PopupMenu:=BackgroundMenu
  else
     PopupMenu:=nil;
end;

procedure TPermanentModule.FileObjPropSheetApplyEx(
  Sender: TSxShellPropSheetExt; PropSheet: TForm;
  var ApplyChanges: Boolean);
begin
  TGrainPropSheetForm(PropSheet).SaveProperties;
  ApplyChanges:=True;
end;

procedure TPermanentModule.DataProviderGetGrainFileInfo(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var FileInfo: TSxFileInfoDescriptor);
var
  tempFileStg:IMDFileObj;
begin
  MDServer.GetRelativeFileStorage(DataGrain.Strings.Values[vGrainPath],tempFileStg);
  if tempFileStg=nil then
     Exit;
  FileInfo.FileAttributes:=DataGrain.Attributes;
  FileInfo.CreationTime:=Now;
  FileInfo.LastAccessTime:=Now;
  FileInfo.LastWriteTime:=Now;
  FileInfo.FileSize:=tempFileStg.Size;
  FileInfo.FileName:=tempFileStg.Name;
  FileInfo.TypeName:=SxGetFileTypeDescription(tempFileStg.Name);
end;

procedure TPermanentModule.DataProviderGetGrainFileContents(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  Stream: TMemoryStream);
var
  tempFileStg:IMDFileObj;
  tempVar:OleVariant;
begin
  MDServer.GetRelativeFileStorage(DataGrain.Strings.Values[vGrainPath],tempFileStg);
  if tempFileStg=nil then
     Exit;
  if Failed(tempFileStg.GetContents(tempVar)) then
     Exit;
  SxVarArrayToStream(tempVar,Stream);
end;

procedure TPermanentModule.DataProviderNewGrainFromStream(
  Sender: TSxCustomProvider; FolderGrain: TSxCustomDataGrain;
  FileInfo: TSxFileInfoDescriptor; FileData: TStream);
var
  tempFileStg:IMDFileObj;
  newFileObj:IMDFileObj;
  tempVar:OleVariant;
begin
  MDServer.GetRelativeFileStorage(FolderGrain.Strings.Values[vGrainPath],tempFileStg);
  if tempFileStg=nil then
     Exit;
  tempFileStg.AddNewChild(FileInfo.FileName,newFileObj);
  if newFileObj=nil then
     Exit;
  newFileObj.ReadOnly:=ftReadOnly in FileInfo.FileAttributes;
  newFileObj.IsSystemIcon:=True;
  newFileObj.Kind:=okFile;
  tempVar:=SxStreamToVarArray(FileData);
  newFileObj.SetContents(tempVar);
  newFileObj.UpdateChanges;
end;

procedure TPermanentModule.DataProviderGrainMoved(
  Sender: TSxCustomProvider; DataGrains: TSxDataGrainList);
var
  i:Integer;
begin
  for i:=0 to DataGrains.Count-1 do
  begin
    MDServer.DeteleFileStgElement(DataGrains[i].Strings.Values[vGrainPath])
  end;
end;

procedure TPermanentModule.DataProviderGetIcon(Sender: TSxCustomProvider;
  DataGrain: TSxCustomDataGrain; var IconIndex, OpenIconIndex: Integer);
var
  tempFileStg:IMDFileObj;
  tempIcon:TIcon;
  tempStream:TMemoryStream;
  tempVar:OleVariant;
begin
  if DataGrain.Strings.Values[vSysIconOnly]='1' then
  begin
    IconIndex:=SxGetFileSystemIcon(DataGrain.Name,False,DataGrain.GrainType=gtFolder);
    if DataGrain.GrainType=gtFolder then
       OpenIconIndex:=SxGetFileSystemIcon(DataGrain.Name,True,DataGrain.GrainType=gtFolder);
  end
  else
  begin
    IconIndex:=0;
    OpenIconIndex:=0;
    tempIcon:=TIcon.Create;
    tempStream:=TMemoryStream.Create;
    try
      MDServer.GetRelativeFileStorage(DataGrain.Strings.Values[vGrainPath],tempFileStg);
      if tempFileStg=nil then
         Exit;

      // retreiving normal icon image and adding it to system image list
      tempFileStg.GetIcon(tempVar);
      SxVarArrayToStream(tempVar,tempStream);
      tempStream.Position:=0;
      IconIndex:=DataProvider.SmallIcons.AddIconFromStream(tempStream);
      tempStream.Position:=0;
      DataProvider.LargeIcons.AddIconFromStream(tempStream); // large icons index is the same as small icon index
      tempStream.Position:=0;
      DataProvider.ExtraLargeIcons.AddIconFromStream(tempStream); // extralarge icons index is the same as small icon index

      // retreiving open icon image from database and adding it to system image list
      tempStream.Position:=0;
      tempFileStg.GetOpenIcon(tempVar);
      SxVarArrayToStream(tempVar,tempStream);
      tempStream.Position:=0;
      OpenIconIndex:=DataProvider.LargeIcons.AddIconFromStream(tempStream);
      tempStream.Position:=0;
      DataProvider.LargeIcons.AddIconFromStream(tempStream); // large icons index is the same as small icon index
      tempStream.Position:=0;
      DataProvider.ExtraLargeIcons.AddIconFromStream(tempStream); // extralarge icons index is the same as small icon index
    finally
      FreeAndNil(tempIcon);
      FreeAndNil(tempStream);
    end;
  end;
end;

procedure TPermanentModule.miAboutClick(Sender: TObject);
begin
  ShowMessage('MegaDemo-NSE');
end;

procedure TPermanentModule.miShowGrainPathClickGrainList(
  Sender: TSxMenuItem; DataGrainList: TSxDataGrainList);
var
  i:Integer;
  tempStr:TStrings;
begin
  tempStr:=TStringList.Create;
  try
    for i:=0 to DataGrainList.Count-1 do
        tempStr.Add(DataGrainList[i].Strings.Values[vGrainPath]);
    if tempStr.Count>0 then
       ShowMessage(tempStr.Text);
  finally
    FreeAndNil(tempStr);
  end;
end;

procedure TPermanentModule.DataProviderPrepareGrainApperance(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var IconParams: TSxPrepareIconParams);
begin
  IconParams.UseSystemIcon:=DataGrain.Strings.Values[vSysIconOnly]='1';
end;

procedure TPermanentModule.DataProviderGetOverlayIndex(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  var OverlayIndex: Integer; var DisplayOverlay: Boolean);
begin
  OverlayIndex:=0;
  if ftReadOnly in DataGrain.Attributes then
     DisplayOverlay:=True
  else
     DisplayOverlay:=False;
end;

procedure TPermanentModule.DataProviderCreateNewFolder(
  Sender: TSxCustomProvider; OwnerFolderGrain: TSxCustomDataGrain;
  NewFolderName: WideString; out NewFolderGrain: TSxCustomDataGrain);
var
  tempFileStg:IMDFileObj;
  tempNewStg:IMDFileObj;
begin
  MDServer.GetRelativeFileStorage(OwnerFolderGrain.Strings.Values[vGrainPath],tempFileStg);
  if tempFileStg=nil then
     Exit;
  tempFileStg.AddNewChild(NewFolderName,tempNewStg);
  NewFolderGrain:=CreateGrainFromStg(tempNewStg,OwnerFolderGrain);
end;

procedure TPermanentModule.DataProviderHandleModify(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain;
  DataStream: TStream);
var
  tempFileStg:IMDFileObj;
  tempVar:OleVariant;
begin
  MDServer.GetRelativeFileStorage(DataGrain.Strings.Values[vGrainPath],tempFileStg);
  if tempFileStg=nil then
     Exit;
  tempVar:=SxStreamToVarArray(DataStream);
  if not VarIsNull(tempVar) then
     tempFileStg.SetContents(tempVar);
  tempFileStg.UpdateChanges;
  Sender.NotifyUpdateGrain(DataGrain);
end;

procedure TPermanentModule.DataProviderValidateDataGrain(
  Sender: TSxCustomProvider; FolderGrain, DataGrain: TSxCustomDataGrain;
  var IsDataGrainValid: Boolean);
var
  tempFileStg:IMDFileObj;
begin
  MDServer.GetRelativeFileStorage(DataGrain.Strings.Values[vGrainPath],tempFileStg);
  IsDataGrainValid:=tempFileStg<>nil;
end;

procedure TPermanentModule.ShellPlusItem2ClickGrain(Sender: TSxMenuItem;
  DataGrain: TSxCustomDataGrain);
begin
  ShowMessage('1. Clicked grain '+DataGrain.Name);
end;

procedure TPermanentModule.ShellPlusItem3ClickGrain(Sender: TSxMenuItem;
  DataGrain: TSxCustomDataGrain);
begin
  ShowMessage('2. Clicked grain '+DataGrain.Name);
end;

procedure TPermanentModule.DataProviderGrainOpen(Sender: TSxCustomProvider;
  DataGrain: TSxCustomDataGrain; var CommandString, Parameters,
  Directory: WideString);
begin
  CommandString:=DataProvider.GetGrainFileRepresentation(DataGrain);
end;

procedure TPermanentModule.SecurityPageGetGenericMapping(
  Sender: TsxCustomExtraPropPage; PropSheets: TSxShellPropSheetExt;
  var Mapping: _GENERIC_MAPPING);
begin
  Mapping.GenericRead:=FILE_GENERIC_READ;
  Mapping.GenericWrite:=FILE_GENERIC_WRITE;
  Mapping.GenericExecute:=FILE_GENERIC_EXECUTE;
  Mapping.GenericAll:=FILE_ALL_ACCESS;
end;

procedure TPermanentModule.SecurityPageGetAccessRights(
  Sender: TsxCustomExtraPropPage; PropSheets: TSxShellPropSheetExt;
  var Access: PSI_ACCESS; var Accesses, DefaultAccess: Cardinal);
begin
  Access:=@access_list;
  Accesses:=19;
  DefaultAccess:=0;
end;

procedure TPermanentModule.DataProviderConfirmOverwriteFolder(
  Sender: TSxCustomProvider; AFolder: TSxCustomDataGrain; wnd: HWND;
  var AllowOverwrite: Boolean);
begin
  ShowMessage('Overwrite');
  AllowOverwrite:=True;
end;

procedure TPermanentModule.DataProviderNewGrainFromFileEx(
  Sender: TSxCustomProvider; FolderGrain: TSxCustomDataGrain;
  FileName: WideString; var NewGrain: TSxCustomDataGrain;
  var DropInfo: TSxDropInfo);
var
  tempFileStg:IMDFileObj;
  newFileObj:IMDFileObj;
  fileStream:TFileStream;
  tempVar:OleVariant;
  i:Integer;
begin
  // retreiving file container from database (Folder in this case)
  MDServer.GetRelativeFileStorage(FolderGrain.Strings.Values[vGrainPath],tempFileStg);
  if tempFileStg=nil then
     Exit;
  // adding new file
  tempFileStg.AddNewChild(ExtractFileName(FileName),newFileObj);
  if newFileObj=nil then
     Exit;
  // specifying file attributes
  newFileObj.ReadOnly:=False;
  newFileObj.IsSystemIcon:=True;
  newFileObj.Kind:=okFile;
  // loading data to database
  fileStream:=TFileStream.Create(FileName,fmShareDenyNone or fmOpenRead);
  try
    tempVar:=SxStreamToVarArray(fileStream);
    if not VarIsNull(tempVar) then
       newFileObj.SetContents(tempVar);
  finally
    FreeAndNil(fileStream);
  end;
  // updating changes into database
  newFileObj.UpdateChanges;
  // returning representation of database object
  NewGrain:=CreateGrainFromStg(newFileObj,FolderGrain);
  // This line specifies that performed operation is "Copy", but not "Move"
  DropInfo.DropEffect:=[sdeCopy];
end;

procedure TPermanentModule.miNewFolderClickGrain(Sender: TSxMenuItem;
  DataGrain: TSxCustomDataGrain);
var
  frmNewGrain:TfrmNewGrain;
  NewGrain:TSxCustomDataGrain;
  tempContext:TSxContext;
begin
  tempContext:=TSxContext.Create;
  try
    frmNewGrain:=TfrmNewGrain.Create(Self);
    try
      if frmNewGrain.ShowModal=mrCancel then
         Exit;
      // Here is an implicit call to DataProvider.OnCreateNewFolder
      DataProvider.DoCreateNewFolder(DataGrain,frmNewGrain.edGrainName.Text,NewGrain);
      if NewGrain<>nil then
         FreeAndNil(NewGrain);
    finally
      FreeAndNil(frmNewGrain);
    end;
  finally
    FreeAndNil(tempContext);
  end;
end;

procedure TPermanentModule.miModifyCurrentItemNameClickGrain(
  Sender: TSxMenuItem; DataGrain: TSxCustomDataGrain);
var
  tempFileStg:IMDFileObj;
  tempPath:TStrings;
  tempGrain:TSxCustomDataGrain; // used later to notify about rename
begin
  tempPath:=TStringList.Create;
  try
    tempGrain:=DataGrain.Clone;
    try
      // Getting parent DataGrain (requirements of MegaDemoServer implementation)
      FilePathToStrings(DataGrain.Strings.Values[vGrainPath], tempPath);
      if tempPath.Count>0 then
         tempPath.Delete(tempPath.Count-1); // deleting last item to get the path of parent item
      MDServer.GetRelativeFileStorage(StringsToFilePath(tempPath),tempFileStg);
      if tempFileStg<>nil then
         tempFileStg.RenameChild(DataGrain.Name,DateToStr(Date)+'_'+DataGrain.Name);
      DataProvider.NotifyRenameGrain(DataGrain, tempGrain);
    finally
      FreeAndNil(tempGrain);
    end;
  finally
    FreeAndNil(tempPath);
  end;
end;

procedure TPermanentModule.DataProviderQueryDataGrainDropEx(
  Sender: TSxCustomProvider; FolderGrain, DataGrain: TSxCustomDataGrain;
  var DropQueryInfo: TSxDropQuery);
// FolderGrain - represents currently opened folder
// DataGrain - represents currently selected folder
begin
  if (FolderGrain.Name='Stored Files') then
     if (DataGrain.Name='Stored Files') then
        DropQueryInfo.AllowedEffects:=[];
end;

procedure TPermanentModule.ShellPlusItem4ClickGrainList(
  Sender: TSxMenuItem; DataGrainList: TSxDataGrainList);
var
  tempData:IDataObject;
begin
  tempData:=TSxNamespaceDataObject.CreateForGrainList(Sender.ShellFolder, DataGrainList, Sender.ExplorerWnd);
  SHMultiFileProperties(tempData, 0);
end;

procedure TPermanentModule.DataProviderGetDataGrainThumb(
  Sender: TSxCustomProvider; DataGrain: TSxCustomDataGrain; Size: TSxSize;
  var Thumb: TBitmap);
begin
  Thumb.Width:=Size.cx;
  Thumb.Height:=Size.cy;
  Thumb.Canvas.Pen.Width:=2;
  Thumb.Canvas.Ellipse(1, 1, Thumb.Width-2, Thumb.Height-2);
  Thumb.Canvas.Font.Name:='Arial';
  Thumb.Canvas.Font.Size:=9;
  Thumb.Canvas.Brush.Style:=bsClear;
  Thumb.Canvas.TextOut((Size.cx div 2)-(Thumb.Canvas.TextWidth(DataGrain.Name) div 2), (Size.cy div 2)-(Thumb.Canvas.TextHeight(DataGrain.Name) div 2), DataGrain.Name);
end;

procedure TPermanentModule.Logout1Click(Sender: TObject);
begin
  DoLogout;
end;

initialization
  RegisterPermanentModuleClass(TPermanentModule);

end.
